/*
 * Ben NanoNote panel-specific definitions
 *
 * Copyright (C) Xiangfu Liu <xiangfu@sharism.cc>
 * Copyright (C) 2015, 2016 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#ifndef __NANONOTE_GPM940B0_H__
#define __NANONOTE_GPM940B0_H__

#include "board.h"
#include "nanonote.h"

static inline void __spi_write_reg1(u8 reg, u8 val)
{
	u8 no, a=reg, b=val;
	u16 value;

	__gpio_set_pin(SPEN);
	__gpio_set_pin(SPCK);
	__gpio_clear_pin(SPDA);
	__gpio_clear_pin(SPEN);

	value = ((a << 8) | (b & 0xFF));

	for (no=0; no<16; no++)
	{
		__gpio_clear_pin(SPCK);

		if ((value & 0x8000) == 0x8000)
			__gpio_set_pin(SPDA);
		else
			__gpio_clear_pin(SPDA);

		__gpio_set_pin(SPCK);
		value = (value << 1);
	}
	__gpio_set_pin(SPEN);
}

static inline void __lcd_display_pin_init()
{
	__cpm_start_tcu();
	__gpio_as_output(SPEN);
	__gpio_as_output(SPCK);
	__gpio_as_output(SPDA);
}

static inline void __lcd_display_on()
{
	__spi_write_reg1(0x05, 0x1e);
	__spi_write_reg1(0x05, 0x5e);
	__spi_write_reg1(0x07, 0x8d);
	__spi_write_reg1(0x13, 0x01);
	__spi_write_reg1(0x05, 0x5f);
}

static inline void __lcd_display_off()
{
	__spi_write_reg1(0x05, 0x5e);
}

#endif /* __NANONOTE_GPM940B0_H__ */
